hdu 1010 Tempter of the Bone 深搜+剪枝

Tempter of the Bone

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 88774    Accepted Submission(s): 24159


Problem Description
The doggie found a bone in an ancient maze, which fascinated him a lot. However, when he picked it up, the maze began to shake, and the doggie could feel the ground sinking. He realized that the bone was a trap, and he tried desperately to get out of this maze.

The maze was a rectangle with sizes N by M. There was a door in the maze. At the beginning, the door was closed and it would open at the T-th second for a short period of time (less than 1 second). Therefore the doggie had to arrive at the door on exactly the T-th second. In every second, he could move one block to one of the upper, lower, left and right neighboring blocks. Once he entered a block, the ground of this block would start to sink and disappear in the next second. He could not stay at one block for more than one second, nor could he move into a visited block. Can the poor doggie survive? Please help him.
 
Input
The input consists of multiple test cases. The first line of each test case contains three integers N, M, and T (1 < N, M < 7; 0 < T < 50), which denote the sizes of the maze and the time at which the door will open, respectively. The next N lines give the maze layout, with each line containing M characters. A character is one of the following:

'X': a block of wall, which the doggie cannot enter;
'S': the start point of the doggie;
'D': the Door; or
'.': an empty block.

The input is terminated with three 0's. This test case is not to be processed.
 
Output
For each test case, print in one line "YES" if the doggie can survive, or "NO" otherwise.
 
Sample Input
4 4 5
S.X.
..X.
..XD
....
3 4 5
S.X.
..X.
...D
0 0 0
 
Sample Output
NO
YES
 
Author
ZHANG, Zheng
 
题意:从起点到终点,要求恰好在时间t到达。若能输出YES,反之,NO;
思路:一开始想着用BFS后来发现BFS求的是最短路径。有可能在不能恰好到达。改成DFS回溯加剪枝。
         2.字符读入,每行都有换行需要用getchar()过滤掉。
 1 #include<cstdio>
 2 #include<cstring>
 3 #include<iostream>
 4 #include<algorithm>
 5 #include<queue>
 6 using namespace std;
 7 #define maxn 50
 8 int n,m,t,flag;
 9 struct Node
10 {
11     int x,y;
12 };
13 Node st,et,k;
14 int dx[]={0,0,-1,1};
15 int dy[]={1,-1,0,0};
16 int vis[maxn][maxn];
17 char map[maxn][maxn];
18 void dfs(int x,int y,int cost)
19 {
20     if(flag==1)
21     return;
22     if(map[x][y]=='D'&&cost==t)//目标状态:步数为,坐标位置为D;
23     {
24         flag=1;
25         return;
26     }
27     int mindis=abs(x-et.x)+abs(y-et.y);  /*当前点到终点的最短距离*/
28     if(mindis>t-cost||( t-cost-mindis )%2!=0)
29         return;//奇偶剪枝
30     for(int i=0;i<4;i++)//扩展方式:上下左右;
31     {
32         int nx=x+dx[i];
33         int ny=y+dy[i];
34         if(!vis[nx][ny]&&nx>=0&&nx<n&&ny>=0&&ny<m&&map[nx][ny]!='X')
35         {
36             //printf("%d %d %d
",nx,ny);
37             vis[nx][ny]=1;
38             dfs(nx,ny,cost+1);
39             vis[nx][ny]=0;
40         }
41 
42     }
43 
44 }
45 
46 int main()
47 {
48     while(~scanf("%d%d%d",&n,&m,&t))
49     {
50         if(n==0||m==0||t==0)
51             break;
52         getchar();
53         for(int i=0;i<n;i++)
54         {
55             for(int j=0;j<m;j++)
56             {
57                 scanf("%c",&map[i][j]);
58                 if(map[i][j]=='S')
59                 {
60                     st.x=i;
61                     st.y=j;
62                 }
63                 if(map[i][j]=='D')
64                 {
65                     et.x=i;
66                     et.y=j;
67                 }
68 
69             }
70             getchar();
71         }
72         flag=0;
73         memset(vis,0,sizeof(vis));
74         vis[st.x][st.y]=1;
75         dfs(st.x,st.y,0);//初始状态:S的位置坐标,步数为0;
76         if(!flag)
77             printf("NO
");
78         else
79             printf("YES
");
80 
81     }
82 
83     return 0;
84 }
原文地址:https://www.cnblogs.com/ZP-Better/p/4639610.html